#include "DXUT.h"
#include "Script/EnumReflectionMap.h"
#include "PxPhysicsAPI.h"
#include "PxEnumReflections.h"

#define ENUM(x) { typedef x STRUCTTYPE; Egg::Script::EnumReflectionMap< x :: Enum >::getMap()
#define FIELD(x) .add( #x , STRUCTTYPE :: x)

using namespace physx;

void Egg::Physics::PxEnumReflections::initialize()
{
	ENUM(PxActorFlag)
		FIELD(eVISUALIZATION)
		FIELD(eDISABLE_GRAVITY)
		FIELD(eSEND_SLEEP_NOTIFIES);}
	ENUM(PxActorType)
		FIELD(eRIGID_STATIC)
		FIELD(eRIGID_DYNAMIC)
		FIELD(ePARTICLE_SYSTEM)
		FIELD(ePARTICLE_FLUID)
		FIELD(eARTICULATION_LINK)
		FIELD(eCLOTH)
		FIELD(eACTOR_COUNT);}
	ENUM(PxBatchQueryStatus)
		FIELD(ePENDING)
		FIELD(eSUCCESS)
		FIELD(eABORTED);}
	ENUM(PxConverterReportMode)
		FIELD(eNONE)
		FIELD(eNORMAL)
		FIELD(eVERBOSE);}
	ENUM(PxCapsuleClimbingMode)
		FIELD(eEASY)
		FIELD(eCONSTRAINED)
		FIELD(eLAST);}
	ENUM(PxClientBehaviorBit)
		FIELD(eREPORT_FOREIGN_OBJECTS_TO_TRIGGER_NOTIFY)
		FIELD(eREPORT_FOREIGN_OBJECTS_TO_CONTACT_NOTIFY)
		FIELD(eREPORT_FOREIGN_OBJECTS_TO_CONSTRAINT_BREAK_NOTIFY)
		FIELD(eREPORT_FOREIGN_OBJECTS_TO_SCENE_QUERY);}
	ENUM(PxActorClientBehaviorBit)
		FIELD(eREPORT_TO_FOREIGN_CLIENTS_TRIGGER_NOTIFY)
		FIELD(eREPORT_TO_FOREIGN_CLIENTS_CONTACT_NOTIFY)
		FIELD(eREPORT_TO_FOREIGN_CLIENTS_CONSTRAINT_BREAK_NOTIFY)
		FIELD(eREPORT_TO_FOREIGN_CLIENTS_SCENE_QUERY);}
	ENUM(PxClothFabricPhaseType)
		FIELD(eINVALID)
		FIELD(eSTRETCHING)
		FIELD(eSTRETCHING_HORIZONTAL)
		FIELD(eBENDING)
		FIELD(eSHEARING)
		FIELD(eZEROSTRETCH)
		FIELD(eBENDING_ANGLE)
		FIELD(eCOUNT);}
	ENUM(PxClothMeshEdgeFlag)
		FIELD(eQUAD_DIAGONAL);}
	ENUM(PxClothMeshVertFlag)
		FIELD(eVF_ATTACHED);}
//			ENUM(PxClothPhaseSolverConfig)
	{ typedef PxClothPhaseSolverConfig STRUCTTYPE; Egg::Script::EnumReflectionMap< PxClothPhaseSolverConfig :: SolverType >::getMap()
		FIELD(eINVALID)
		FIELD(eFAST)
		FIELD(eSTIFF)
		FIELD(eBENDING)
		FIELD(eZEROSTRETCH)
		FIELD(eSHEARING);}
	ENUM(PxClothFlag)
		FIELD(eSWEPT_CONTACT)
		FIELD(eGPU);}
	{ typedef PxConstraintFlag STRUCTTYPE; Egg::Script::EnumReflectionMap< PxConstraintFlag :: Type >::getMap()
		FIELD(eBROKEN)
		FIELD(ePROJECTION)
		FIELD(eCOLLISION_ENABLED)
		FIELD(eREPORTING)
		FIELD(eVISUALIZATION);}
	{ typedef Px1DConstraintFlag STRUCTTYPE; Egg::Script::EnumReflectionMap< Px1DConstraintFlag :: Type >::getMap()
		FIELD(eSPRING)
		FIELD(eACCELERATION_SPRING)
		FIELD(eRESTITUTION)
		FIELD(eKEEPBIAS)
		FIELD(eOUTPUT_FORCE);}
	ENUM(PxConstraintVisualizationFlag)
		FIELD(eLOCAL_FRAMES)
		FIELD(eLIMITS);}
	ENUM(PxConstraintExtIDs)
		FIELD(eJOINT)
		FIELD(eVEHICLE_SUSP_LIMIT)
		FIELD(eVEHICLE_STICKY_TYRE)
		FIELD(eNEXT_FREE_ID)
		FIELD(eINVALID_ID);}
	ENUM(PxControllerBehaviorFlag)
		FIELD(eCCT_CAN_RIDE_ON_OBJECT)
		FIELD(eCCT_SLIDE);}
	ENUM(PxControllerShapeType)
		FIELD(eBOX)
		FIELD(eCAPSULE);}
	ENUM(PxCCTInteractionMode)
		FIELD(eINCLUDE)
		FIELD(eEXCLUDE)
		FIELD(eUSE_FILTER);}
	ENUM(PxCCTNonWalkableMode)
		FIELD(ePREVENT_CLIMBING)
		FIELD(eFORCE_SLIDING);}
	ENUM(PxControllerFlag)
		FIELD(eCOLLISION_SIDES)
		FIELD(eCOLLISION_UP)
		FIELD(eCOLLISION_DOWN);}
	ENUM(PxControllerDebugRenderFlags)
		FIELD(eTEMPORAL_BV)
		FIELD(eCACHED_BV)
		FIELD(eOBSTACLES)
		FIELD(eALL);}
	ENUM(PxConvexFlag)
		FIELD(eFLIPNORMALS)
		FIELD(e16_BIT_INDICES)
		FIELD(eCOMPUTE_CONVEX)
		FIELD(eINFLATE_CONVEX)
		FIELD(eUSE_UNCOMPRESSED_NORMALS);}
	ENUM(PxPlatform)
		FIELD(ePC)
		FIELD(eXENON)
		FIELD(ePLAYSTATION3)
		FIELD(eWII)
		FIELD(eARM);}
	ENUM(PxD6Axis)
		FIELD(eX)
		FIELD(eY)
		FIELD(eZ)
		FIELD(eTWIST)
		FIELD(eSWING1)
		FIELD(eSWING2)
		FIELD(eCOUNT);}
	ENUM(PxD6Motion)
		FIELD(eLOCKED)
		FIELD(eLIMITED)
		FIELD(eFREE);}
	ENUM(PxD6Drive)
		FIELD(eX)
		FIELD(eY)
		FIELD(eZ)
		FIELD(eSWING)
		FIELD(eTWIST)
		FIELD(eSLERP)
		FIELD(eCOUNT);}
	ENUM(PxD6JointDriveFlag)
		FIELD(eACCELERATION);}
	ENUM(PxDistanceJointFlag)
		FIELD(eMAX_DISTANCE_ENABLED)
		FIELD(eMIN_DISTANCE_ENABLED)
		FIELD(eSPRING_ENABLED);}
	ENUM(PxErrorCode)
		FIELD(eNO_ERROR)
		FIELD(eDEBUG_INFO)
		FIELD(eDEBUG_WARNING)
		FIELD(eINVALID_PARAMETER)
		FIELD(eINVALID_OPERATION)
		FIELD(eOUT_OF_MEMORY)
		FIELD(eINTERNAL_ERROR)
		FIELD(eABORT)
		FIELD(ePERF_WARNING)
		FIELD(eEXCEPTION_ON_STARTUP)
		FIELD(eMASK_ALL);}
	ENUM(PxField)
		FIELD(eUNDEFINED)
		FIELD(eBYTE)
		FIELD(eWORD)
		FIELD(eDWORD)
		FIELD(eFLOAT)
		FIELD(eVEC3)
		FIELD(eSTRING)
		FIELD(eSERIAL_PTR)
		FIELD(eSERIAL_EMBEDDED)
		FIELD(ePX_ARRAY)
		FIELD(eLAST);}
	ENUM(PxPairFlag)
		FIELD(eRESOLVE_CONTACTS)
		FIELD(eMODIFY_CONTACTS)
		FIELD(eNOTIFY_TOUCH_FOUND)
		FIELD(eNOTIFY_TOUCH_PERSISTS)
		FIELD(eNOTIFY_TOUCH_LOST)
		FIELD(eNOTIFY_THRESHOLD_FORCE_FOUND)
		FIELD(eNOTIFY_THRESHOLD_FORCE_PERSISTS)
		FIELD(eNOTIFY_THRESHOLD_FORCE_LOST)
		FIELD(eNOTIFY_CONTACT_POINTS)
		FIELD(eSWEPT_INTEGRATION_LINEAR)
		FIELD(eCONTACT_DEFAULT)
		FIELD(eTRIGGER_DEFAULT);}
	ENUM(PxFilterFlag)
		FIELD(eKILL)
		FIELD(eSUPPRESS)
		FIELD(eCALLBACK)
		FIELD(eNOTIFY)
		FIELD(eDEFAULT);}
	ENUM(PxFilterObjectType)
		FIELD(eRIGID_STATIC)
		FIELD(eRIGID_DYNAMIC)
		FIELD(ePARTICLE_SYSTEM)
		FIELD(ePARTICLE_FLUID)
		FIELD(eARTICULATION)
		FIELD(eMAX_TYPE_COUNT)
		FIELD(eUNDEFINED);}
	ENUM(PxFilterObjectFlags)
		FIELD(eKINEMATIC)
		FIELD(eTRIGGER);}
	ENUM(PxForceMode)
		FIELD(eFORCE)
		FIELD(eIMPULSE)
		FIELD(eVELOCITY_CHANGE)
		FIELD(eACCELERATION);}
	ENUM(PxGeometryType)
		FIELD(eSPHERE)
		FIELD(ePLANE)
		FIELD(eCAPSULE)
		FIELD(eBOX)
		FIELD(eCONVEXMESH)
		FIELD(eTRIANGLEMESH)
		FIELD(eHEIGHTFIELD)
		FIELD(eGEOMETRY_COUNT)
		FIELD(eINVALID);}
	ENUM(PxHeightFieldFormat)
		FIELD(eS16_TM);}
	ENUM(PxHeightFieldTessFlag)
		FIELD(e0TH_VERTEX_SHARED);}
	ENUM(PxHeightFieldFlag)
		FIELD(eNO_BOUNDARY_EDGES);}
	ENUM(PxHeightFieldMaterial)
		FIELD(eHOLE);}
	ENUM(PxJointType)
		FIELD(eD6)
		FIELD(eDISTANCE)
		FIELD(eFIXED)
		FIELD(ePRISMATIC)
		FIELD(eREVOLUTE)
		FIELD(eSPHERICAL);}
	ENUM(PxJointActorIndex)
		FIELD(eACTOR0)
		FIELD(eACTOR1);}
	ENUM(PxDataAccessFlag)				
		FIELD(eREADABLE)
		FIELD(eWRITABLE);}
	ENUM(PxMaterialFlag)
		FIELD(eDISABLE_FRICTION)
		FIELD(eDISABLE_STRONG_FRICTION);}
	ENUM(PxCombineMode)
		FIELD(eAVERAGE)
		FIELD(eMIN)
		FIELD(eMULTIPLY)
		FIELD(eMAX)
		FIELD(eN_VALUES);}
	ENUM(PxObservableType)
		FIELD(eActor);}
	ENUM(PxParticleBaseFlag)
		FIELD(eCOLLISION_TWOWAY)
		FIELD(eCOLLISION_WITH_DYNAMIC_ACTORS)
		FIELD(eENABLED)
		FIELD(ePROJECT_TO_PLANE)
		FIELD(ePER_PARTICLE_REST_OFFSET)
		FIELD(ePER_PARTICLE_COLLISION_CACHE_HINT)
		FIELD(eGPU);}
	ENUM(PxParticleFlag)
		FIELD(eVALID)
		FIELD(eCOLLISION_WITH_STATIC)
		FIELD(eCOLLISION_WITH_DYNAMIC)
		FIELD(eCOLLISION_WITH_DRAIN)
		FIELD(eSPATIAL_DATA_STRUCTURE_OVERFLOW);}
	ENUM(PxParticleReadDataFlag)
		FIELD(ePOSITION_BUFFER)
		FIELD(eVELOCITY_BUFFER)
		FIELD(eREST_OFFSET_BUFFER)
		FIELD(eFLAGS_BUFFER)
		FIELD(eCOLLISION_NORMAL_BUFFER)
		FIELD(eDENSITY_BUFFER);}
	ENUM(PxCookingValue)
		FIELD(eCONVEX_VERSION_PC)
		FIELD(eMESH_VERSION_PC)
		FIELD(eCONVEX_VERSION_XENON)
		FIELD(eMESH_VERSION_XENON)
		FIELD(eCONVEX_VERSION_PLAYSTATION3)
		FIELD(eMESH_VERSION_PLAYSTATION3);}
	ENUM(PxPrismaticJointFlag)	
		FIELD(eLIMIT_ENABLED);}
	ENUM(PxDebugColor)
		FIELD(eARGB_BLACK)
		FIELD(eARGB_RED)
		FIELD(eARGB_GREEN)
		FIELD(eARGB_BLUE)
		FIELD(eARGB_YELLOW)
		FIELD(eARGB_MAGENTA)
		FIELD(eARGB_CYAN)
		FIELD(eARGB_WHITE)
		FIELD(eARGB_GREY)
		FIELD(eARGB_DARKRED)
		FIELD(eARGB_DARKGREEN)
		FIELD(eARGB_DARKBLUE);}
	ENUM(PxRevoluteJointFlag)
		FIELD(eLIMIT_ENABLED)
		FIELD(eDRIVE_ENABLED)
		FIELD(eDRIVE_FREESPIN);}
	ENUM(PxRigidDynamicFlag)
		FIELD(eKINEMATIC);}
	ENUM(PxPruningStructure)
		FIELD(eNONE)
		FIELD(eDYNAMIC_AABB_TREE)
		FIELD(eSTATIC_AABB_TREE);}
	ENUM(PxSceneFlag)
		FIELD(eDISABLE_SSE)
		FIELD(eENABLE_ACTIVETRANSFORMS)
		FIELD(eENABLE_SWEPT_INTEGRATION)
		FIELD(eADAPTIVE_FORCE)
		FIELD(eENABLE_KINEMATIC_STATIC_PAIRS)
		FIELD(eENABLE_KINEMATIC_PAIRS)
		FIELD(eENABLE_ONE_DIRECTIONAL_FRICTION)
		FIELD(eENABLE_TWO_DIRECTIONAL_FRICTION)
		FIELD(eENABLE_PCM)
		FIELD(eDISABLE_CONTACT_REPORT_BUFFER_RESIZE);}
	ENUM(PxActorTypeSelectionFlag)
		FIELD(eRIGID_STATIC)
		FIELD(eRIGID_DYNAMIC)
		FIELD(ePARTICLE_SYSTEM)
		FIELD(ePARTICLE_FLUID)
		FIELD(eCLOTH);}
	ENUM(PxSceneQueryFilterFlag)
		FIELD(eSTATIC)
		FIELD(eDYNAMIC)
		FIELD(ePREFILTER)
		FIELD(ePOSTFILTER)
		FIELD(eMESH_MULTIPLE)
		FIELD(eBACKFACE);}
	ENUM(PxSceneQueryHitType)
		FIELD(eNONE)
		FIELD(eTOUCH)
		FIELD(eBLOCK);}
	ENUM(PxSceneQueryFlag)
		FIELD(eIMPACT)
		FIELD(eNORMAL)
		FIELD(eDISTANCE)
		FIELD(eUV)
		FIELD(eINITIAL_OVERLAP)
		FIELD(eINITIAL_OVERLAP_KEEP)
		FIELD(eTOUCHING_HIT)
		FIELD(eBLOCKING_HIT);}
	ENUM(PxSceneQueryReportResult)
		FIELD(eCONTINUE)
		FIELD(eABORT_QUERY);}
	ENUM(PxSerialOrder)
		FIELD(eCONVEX)
		FIELD(eTRIMESH)
		FIELD(eHEIGHTFIELD)
		FIELD(eDEFMESH)
		FIELD(eCLOTHMESH)
		FIELD(eMATERIAL)
		FIELD(eSHAPE)
		FIELD(eSTATIC)
		FIELD(eDYNAMIC)
		FIELD(eDEFAULT)
		FIELD(eARTICULATION)
		FIELD(eJOINT)
		FIELD(eCONSTRAINT)
		FIELD(eAGGREGATE);}
	ENUM(PxSerialFlag)
		FIELD(eOWNS_MEMORY)
		FIELD(eDISABLE_AUTO_RESOLVE)
		FIELD(eDISABLE_FIELDS)
		FIELD(eIN_SCENE);}
	ENUM(PxShapeFlag)
		FIELD(eSIMULATION_SHAPE)
		FIELD(eSCENE_QUERY_SHAPE)
		FIELD(eTRIGGER_SHAPE)
		FIELD(eVISUALIZATION)
		FIELD(ePARTICLE_DRAIN)
		FIELD(eUSE_SWEPT_BOUNDS);}
	ENUM(PxMeshFlag)
		FIELD(eFLIPNORMALS)
		FIELD(e16_BIT_INDICES);}
	ENUM(PxContactPairHeaderFlag)
		FIELD(eDELETED_ACTOR_0)
		FIELD(eDELETED_ACTOR_1);}
	ENUM(PxContactPairFlag)
		FIELD(eDELETED_SHAPE_0)
		FIELD(eDELETED_SHAPE_1)
		FIELD(eACTOR_PAIR_HAS_FIRST_TOUCH)
		FIELD(eACTOR_PAIR_LOST_TOUCH)
		FIELD(eINTERNAL_HAS_FACE_INDICES)
		FIELD(eINTERNAL_HAS_IMPULSES)
		FIELD(eINTERNAL_CONTACTS_ARE_FLIPPED);}
	ENUM(PxTriggerPairFlag)
		FIELD(eDELETED_SHAPE_TRIGGER)
		FIELD(eDELETED_SHAPE_OTHER);}
	ENUM(PxSphericalJointFlag)				
		FIELD(eLIMIT_ENABLED);}
	ENUM(PxMeshGeometryFlag)
		FIELD(eDOUBLE_SIDED);}
	ENUM(PxConcreteType)
		FIELD(eUNDEFINED)
		FIELD(eHEIGHTFIELD)
		FIELD(eCONVEX_MESH)
		FIELD(eTRIANGLE_MESH)
		FIELD(eCLOTH_FABRIC)
		FIELD(eRIGID_DYNAMIC)
		FIELD(eRIGID_STATIC)
		FIELD(eSHAPE)
		FIELD(eMATERIAL)
		FIELD(eCONSTRAINT)
		FIELD(eCLOTH)
		FIELD(ePARTICLE_SYSTEM)
		FIELD(ePARTICLE_FLUID)
		FIELD(eAGGREGATE)
		FIELD(eARTICULATION)
		FIELD(eARTICULATION_LINK)
		FIELD(eARTICULATION_JOINT)
		FIELD(eUSER_SPHERICAL_JOINT)
		FIELD(eUSER_REVOLUTE_JOINT)
		FIELD(eUSER_PRISMATIC_JOINT)
		FIELD(eUSER_FIXED_JOINT)
		FIELD(eUSER_DISTANCE_JOINT)
		FIELD(eUSER_D6_JOINT)
		FIELD(eUSER_OBSERVER)
		FIELD(eLAST);}
	ENUM(PxVisualDebuggerFlags)
		FIELD(eTRANSMIT_CONTACTS);}
	ENUM(PxVisualizationParameter)
		FIELD(eSCALE)
		FIELD(eWORLD_AXES)
		FIELD(eBODY_AXES)
		FIELD(eBODY_MASS_AXES)
		FIELD(eBODY_LIN_VELOCITY)
		FIELD(eBODY_ANG_VELOCITY)
		FIELD(eBODY_JOINT_GROUPS)
		FIELD(eCONTACT_POINT)
		FIELD(eCONTACT_NORMAL)
		FIELD(eCONTACT_ERROR)
		FIELD(eCONTACT_FORCE)
		FIELD(eACTOR_AXES)
		FIELD(eCOLLISION_AABBS)
		FIELD(eCOLLISION_SHAPES)
		FIELD(eCOLLISION_AXES)
		FIELD(eCOLLISION_COMPOUNDS)
		FIELD(eCOLLISION_FNORMALS)
		FIELD(eCOLLISION_EDGES)
		FIELD(eCOLLISION_STATIC)
		FIELD(eCOLLISION_DYNAMIC)
		FIELD(eCOLLISION_PAIRS)
		FIELD(eJOINT_LOCAL_FRAMES)
		FIELD(eJOINT_LIMITS)
		FIELD(ePARTICLE_SYSTEM_POSITION)
		FIELD(ePARTICLE_SYSTEM_VELOCITY)
		FIELD(ePARTICLE_SYSTEM_COLLISION_NORMAL)
		FIELD(ePARTICLE_SYSTEM_BOUNDS)
		FIELD(ePARTICLE_SYSTEM_GRID)
		FIELD(ePARTICLE_SYSTEM_BROADPHASE_BOUNDS)
		FIELD(ePARTICLE_SYSTEM_MAX_MOTION_DISTANCE)
		FIELD(eCULL_BOX);}

}
