#pragma once
#include "App/App.h"
#include "Mesh/Shaded.h"
#include "Mesh/Binder.h"
#include "Cam/FirstPerson.h"


class Game :
	public Egg::App
{
	Egg::Mesh::Binder::P binder;
	Egg::Mesh::Shaded::P shadedMesh;
	Egg::Mesh::Shaded::P backgroundQuad;
	Egg::Cam::FirstPerson::P firstPersonCam;

	ID3D11ShaderResourceView* kdSrv;
	ID3D11ShaderResourceView* 	envSrv;

public:
	Game(ID3D11Device* device);
	~Game(void);

	std::string getMainEffectFilename(){ return "main.fx";}

	HRESULT createResources();
	HRESULT releaseResources();
	HRESULT createSwapChainResources();
	HRESULT releaseSwapChainResources();

	void render(ID3D11DeviceContext* context);

	void animate(double dt, double t);
	bool processMessage( HWND hWnd, 
		UINT uMsg, WPARAM wParam, LPARAM lParam);
};

